if(!strLen($Pref::Server::MaxHealth_SaveFile))
	$Pref::Server::MaxHealth_SaveFile = "config/server/MaxHealth.cs";

if(!strLen($Pref::Server::MaxHealth2_SaveFile))
	$Pref::Server::MaxHealth2_SaveFile = "config/server/MaxHealth2.cs";

function serverCmdToggleHealthSaver(%this)
{
	if(!%this.isSuperAdmin)
		return;
	$Pref::Server::MaxHealth_Enabled = !$Pref::Server::MaxHealth_Enabled;
	if($Pref::Server::MaxHealth_Enabled)
	{
		registerOutputEvent("Player","saveHealth");
		registerOutputEvent("Player","loadHealth");	
	}
	else
	{
		unRegisterOutputEvent("Player","saveHealth");
		unRegisterOutputEvent("Player","loadHealth");
	}

	%this.chatMessage("Health saver is now " @ ($Pref::Server::MaxHealth_Enabled == false ? "disabled, removing the event from the event list." : "enabled, adding the event from the event list."));
	for(%i=0;%i<ClientGroup.getCount();%i++)
		serverCmdRequestEventTables(ClientGroup.getObject(%i)); //This might break someone if they are eventing :(
}

function Player::saveHealth(%this)
{
	if(!isObject(%client = %this.client))
		return;

	%path = $Pref::Server::MaxHealth_SaveFile;
	$MaxHealth_[%client.getBLID()] = %this.getHealth() SPC %this.getMaxHealth();
	if($Sim::Time - $lastHealthSave > 10)
	{
		$lastHealthSave = $Sim::Time;
		export("$MaxHealth_*",%path);
	}
}

function Player::loadHealth(%this)
{
	if(!isObject(%client = %this.client))
		return;

	%line = $MaxHealth_[%client.getBLID()];
	if(getWordCount(%line) == 2)
	{
		%this.setHealth(getWord(%line, 0));
		%this.setMaxHealth(getWord(%line, 1));
	}
}

function GameConnection::saveHealth(%this, %bool)
{	
	if(%this.maxHealth < 0 || %this.maxHealth $= "")
	{
		$MaxHealthCL_[%this.getBLID()] = 0;
		if($Sim::Time - $lastHealthSave2 > 10)
		{
			$lastHealthSave2 = $Sim::Time;
			export("$MaxHealthCL*", %path);
		}
	
		return;
	}

	%path = $Pref::Server::MaxHealth2_SaveFile;
	$MaxHealthCL_[%this.getBLID()] = %bool;
	$MaxHealthCLHP_[%this.getBLID()] = %this.health;
	$MaxHealthCLMaxHP_[%this.getBLID()] = %this.maxHealth;

	if($Sim::Time - $lastHealthSave2 > 10)
	{
		$lastHealthSave2 = $Sim::Time;
		export("$MaxHealthCL*", %path);
	}
}

if(!strLen($Pref::Server::MaxHealth_Enabled))
	$Pref::Server::MaxHealth_Enabled = false;

if(isFile($Pref::Server::MaxHealth_SaveFile))
	exec($Pref::Server::MaxHealth_SaveFile);

if(isFile($Pref::Server::MaxHealth2_SaveFile))
	exec($Pref::Server::MaxHealth2_SaveFile);
	
if($Pref::Server::MaxHealth_Enabled)
{
	registerOutputEvent("Player", "saveHealth");
	registerOutputEvent("Player", "loadHealth");
	registerOutputEvent("GameConnection", "saveHealth", "bool");
}